% AMT - Experiments reproducing model results
%
%   Common functions and applications
%     EXP_GAMMATONE        - Figures from Gammatone-related publications
%     EXP_ENGEL2021        - Figures from Engel et al. (2021)
%
%   Basilar membrane velocity
%     EXP_HOHMANN2002      - Figures from Hohmann (2002)
%     EXP_LOPEZPOVEDA2001  - Iso-itensity curves of the lopezpoveda2001
%     EXP_VERHULST2012     - Figures from Verhulst et al. (2012)
%
%   Auditory nerve
%     EXP_BRUCE2018        - Auditory nerve neurogram
%     EXP_OSSES2022        - Comparison of monaural models
% 
%   Temporal modulation sensitivity
%     EXP_RELANOIBORRA2019     - Figures from Relano-Iborra et al. (2019)
%     EXP_ROENNE2012       - Auditory nerve latency
%     EXP_VERHULST2018         - Verhulst et al. 2018
%
%   Binaural processing
%     EXP_DIETZ2011             - Binaural azimuth estimation
%     EXP_LINDEMANN1986         - Calculate a binaural activity map
%     EXP_TAKANEN2013           - Binaural count-comparison model
%
%   Loudness
%     EXP_CHEN2011              - Fast excitation pattern estimation
%     EXP_GLASBERG2002          - Figures from Glasberg et al. (2002)
%     EXP_MOORE1997             - Figures from Moore et al. (1997)
%
%   Monaural speech perception
%     EXP_JOERGENSEN2011        - Speech-based envelope power spectrum
%
%   Binaural speech perception
%     EXP_JELFS2011             - Binaural speech intelligibility advantage
%
%   Perceptual similarity
%     EXP_MCKENZIE2021          - binaural perceptual similarity
%     EXP_OSSES2021             - monaural perceptual similarity
%
%   HRTF models
%     EXP_STEIDLE2019      - Figures from Steidle and Baumgartner (2019)
%     EXP_ZIEGELWANGER2013 - Figures from Ziegelwanger et al. (2013)
%     EXP_ZIEGELWANGER2014 - Figures from Ziegelwanger and Majdak (2014)
%
%   Spatial models
%     EXP_BAUMGARTNER2013  - Figures from Baumgartner et al. (2013)
%     EXP_DIETZ2011        - Figures from Dietz et al. (2011)
%     EXP_GEORGANTI2013    - Figures from Georganti et al. (2013)
%
%   Url: http://amtoolbox.sourceforge.net/amt-0.10.0/doc/experiments/Contents.php

% Copyright (C) 2009-2020 Piotr Majdak and the AMT team.
% This file is part of Auditory Modeling Toolbox (AMT) version 1.0.0
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.

