% AMT - Model-specific plot functions
%
%
%  Model-related plot functions
%     PLOT_AUDSPECGRAM                       - plots an auditory spectrogram
%     PLOT_BAUMGARTNER2013                   - plot probabilistic prediction matrixes
%     PLOT_BAUMGARTNER2014                   - plot probabilistic prediction matrixes
%     plot_baumgartner2014_likelistat        - Likelihood statistics in the model
%     PLOT_BRUCE2018                         - plot the output of the bruce2018 model
%     PLOT_JOERGENSEN2011                    - Plot output of Joergensen2011 model
%     PLOT_JOERGENSEN2013                    - Plot output of Joergensen2013 model
%     PLOT_KELVASA2015                       - Plot the output of the Kelvasa2015 model
%     PLOT_LANGENDIJK2002                    - Plot the pdf-matrices with grey colormap
%     PLOT_langendijk2002_likelihood         - Plot the likelihood statistics
%     PLOT_LINDEMANN1986                     - plot of lindemann1986 model
%     PLOT_MCKENZIE2021                      - plots from McKenzie et al. 2021
%     PLOT_MODSPECGRAM                       - plot modulation spectrogram
%     PLOT_MOORE2016                         - plots from Moore et al. 2016
%     plot_reijniers2014                     - Plot spherical representation of a vector, e.g., localization errors
%     PLOT_ROENNE2012                        - Plot output of roenne2012
%     PLOT_roenne2012_chirp                  - Plot output of roenne2012_chirp
%     PLOT_roenne2012_tonebursts             - Plot output of roenne2012_tonebursts
%     PLOT_STMODSPECGRAM                     - Spectro-Temporal Modulation spectrogram
%     PLOT_ZIEGELWANGER2013                  - Plot the binaural activity map
%
%   Url: http://amtoolbox.sourceforge.net/amt-0.10.0/doc/plot/Contents.php

% Copyright (C) 2009-2020 Piotr Majdak and the AMT team.
% This file is part of Auditory Modeling Toolbox (AMT) version 1.0.0
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%     PLOT_ZIEGELWANGER2014                  - Plot the output of the Ziegelwanger2014 model
