% AMT - Signals
%
%  Monaural signal generators
%    sig_bandpassnoise  -  Bandpass noise
%    sig_linsweep       -  Linear (perfect) frequency sweep
%    sig_notchednoise   -  Notched noise
%    sig_transposedtone -  Transposed tone stimuli
%
%  Impulse responses
%    sig_joergensen2011 - Simulated monaural room impulse responses
%
%  Binaural signal generators
%    sig_bincorrnoise   -  Interaurally correlated noise
%    sig_itdsin         -  Sinusoid with interaural time difference
%    sig_ildsin         -  Sinusoid with interaural level difference
%    sig_itdildsin      -  Sinusoid with interaural time and level difference
%    sig_lindemann1986  -  Binaural modulated sinusoid
%    sig_yost1996       -  Generate iterated rippled noise from Yost (1996)
%
%  Binaural test signals
%    sig_baumgartner2017looming - flattens magnitude spectra of HRTFs acc. to Baumgartner et al. (2017)
%    sig_boyd2012 - HRTF mix from Boyd et al. (2012)
%    sig_breebaart2001 - Generates a binaural signals with narrow-band noise 
%    sig_competingtalkers - Several different competing talker signal
%    sig_hartmann1996 - Complex tone from Hartmann and Wittenberg (1996)
%    sig_hassager2016 - spectral smoothing algorithm from Hassager et al. (2016)
%    sig_li2020 - Modification of HRTFs/BRIRs for the Li2020 experiments
%
%   Url: http://amtoolbox.sourceforge.net/amt-0.10.0/doc/signals/Contents.php

% Copyright (C) 2009-2020 Piotr Majdak and the AMT team.
% This file is part of Auditory Modeling Toolbox (AMT) version 1.0.0
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%    sig_whitenoiseburst - Noise burst to predict perceived direction, used by Wierstorf2013
